/*******************************************************************
 * WAV$B%*!<%G%#%*%W%l!<%d(B
 *  dsPIC33FJ64GP802$B$N%*!<%G%#%*(BDAC$B$N;HMQNc(B
 * $B!!(BSD$B%+!<%IFb$N(BWAV$B%U%!%$%k$r:F@8$9$k!"(B
 *******************************************************************/
#include <xc.h>
#include "GenericTypeDefs.h"
#include "FSIO.h"
/* $B%3%s%U%#%.%e%l!<%7%g%s$N@_Dj(B */
// FBS
#pragma config BWRP = WRPROTECT_OFF     // Boot Segment Write Protect (Boot Segment may be written)
#pragma config BSS = NO_FLASH           // Boot Segment Program Flash Code Protection (No Boot program Flash segment)
#pragma config RBS = NO_RAM             // Boot Segment RAM Protection (No Boot RAM)
// FSS
#pragma config SWRP = WRPROTECT_OFF     // Secure Segment Program Write Protect (Secure segment may be written)
#pragma config SSS = NO_FLASH           // Secure Segment Program Flash Code Protection (No Secure Segment)
#pragma config RSS = NO_RAM             // Secure Segment Data RAM Protection (No Secure RAM)
// FGS
#pragma config GWRP = OFF               // General Code Segment Write Protect (User program memory is not write-protected)
#pragma config GSS = OFF                // General Segment Code Protection (User program memory is not code-protected)
// FOSCSEL
#pragma config FNOSC = FRCPLL           // Oscillator Mode (Internal Fast RC (FRC) w/ PLL)
#pragma config IESO = OFF               // Internal External Switch Over Mode (Start-up device with user-selected oscillator source)
// FOSC
#pragma config POSCMD = NONE            // Primary Oscillator Source (Primary Oscillator Disabled)
#pragma config OSCIOFNC = ON            // OSC2 Pin Function (OSC2 pin has digital I/O function)
#pragma config IOL1WAY = OFF            // Peripheral Pin Select Configuration (Allow Multiple Re-configurations)
#pragma config FCKSM = CSDCMD           // Clock Switching and Monitor (Both Clock Switching and Fail-Safe Clock Monitor are disabled)
// FWDT
#pragma config WDTPOST = PS32768        // Watchdog Timer Postscaler (1:32,768)
#pragma config WDTPRE = PR128           // WDT Prescaler (1:128)
#pragma config WINDIS = OFF             // Watchdog Timer Window (Watchdog Timer in Non-Window mode)
#pragma config FWDTEN = OFF             // Watchdog Timer Enable (Watchdog timer enabled/disabled by user software)
// FPOR
#pragma config FPWRT = PWR64            // POR Timer Value (64ms)
#pragma config ALTI2C = OFF             // Alternate I2C  pins (I2C mapped to SDA1/SCL1 pins)
// FICD
#pragma config ICS = PGD2               // Comm Channel Select (Communicate on PGC2/EMUC2 and PGD1/EMUD1)
#pragma config JTAGEN = OFF             // JTAG Port Enable (JTAG is Disabled)
/* MDD$B%U%!%$%kMQ9=B$BN$N%]%$%s%?JQ?t(B  */
FSFILE  *fptr;
FSFILE  fsAttr;
size_t  result, count;
SearchRec Record;
SearchRec *rptr = &Record;
__attribute__((far)) unsigned char BufferA[4096];   // $B%P%C%U%!(BA
__attribute__((far)) unsigned char BufferB[4096];   // $B%P%C%U%!(BB
/* $B%0%m!<%P%kJQ?t!"Dj?tDj5A(B */
int i, j, k, Mode, Flag, SDFlag, EndFlag;
int State, Index, cursave, RcvFlag;
unsigned int ptr, ptrA, ptrB;
unsigned char RcvBuf[32], SndBuf[32], Buffer[32];
__attribute__((far)) unsigned char DirList[1500];
union uName{
    unsigned short int sName;
    unsigned char bName[3];
};
union uName Name[64];
unsigned char Serch[12];
unsigned short int * nameptr;
/* $B%$%s%U%i%b!<%IMQ$N(BWiFi $B@_DjMQ%3%^%s%I%G!<%?(B */
const unsigned char msg1[] = "$$$";                                 // $B%3%^%s%I%b!<%I;XDj(B
const unsigned char msg2[] = "factory R\r";                         // $B=i4|2=(B
const unsigned char msg3[] = "set wlan ssid 000A79E7Fxxx\r";        // AP$B$N(BSSID$B;XDj(B
const unsigned char msg4[] = "set wlan pass xxxxxxxx\r";            // AP$BMQ%M%C%H%o!<%/%-!<;XDj(B
const unsigned char msg41[] = "set opt deviceid My_Wi-Fi_Audio\r";  // $BL>>N;XDj(B
const unsigned char msg5[] = "set ip proto 3\r";                    // UDP/TCP$B;XDj(B
const unsigned char msg51[] = "set wlan join 1\r";                  // $B<+F0@\B3(B
const unsigned char msg6[] = "set ip host 192.168.1.21\r";          // $B%/%i%$%"%s%HB&%"%I%l%9;XDj(B21
const unsigned char msg7[] = "set ip remote 3000\r";                // $B%/%i%$%"%s%HB&%]!<%H;XDj(B
const unsigned char msg8[] = "set ip local 2000\r";                 // $B<+J,$N%]!<%H;XDj(B
const unsigned char msg9[] = "set b i 0\r";                         // $B%V%m!<%I%-%c%9%HDd;_(B
const unsigned char msg10[] = "set comm remote 0\n";                // Hello$B%a%C%;!<%86X;_(B
const unsigned char msg11[] = "set comm open 0\r";                  // Open$B%a%C%;!<%86X;_(B
const unsigned char msg12[] = "save\r";                             // $B@_DjJ]B8(B
const unsigned char msg13[] = "reboot\r";                           // $B:F5/F0(B
const unsigned char msg14[] = "close\r";                            // TCP$B%/%m!<%:%3%^%s%I(B
/* $B%=%U%H(BAP$B%b!<%IMQ$N%3%^%s%I%G!<%?(B*/
const unsigned char msg21[] = "set wlan join 7\r";                  // $B%=%U%H(BAP$B%b!<%I;XDj(B
const unsigned char msg22[] = "set wlan ssid MyAudio\r";            // SSID$B@_Dj(B
const unsigned char msg23[] = "set ip dhcp 4\r";                    // DHCP$B%5!<%PM-8z2=(B
const unsigned char msg24[] = "set ip address 1.2.3.5\r";           // IP$B%"%I%l%9(B
const unsigned char msg25[] = "set ip net 255.255.255.0\r";         // $B%5%V%M%C%H%^%9%/(B
const unsigned char msg26[] = "set ip gateway 1.2.3.5\r";           // $B%2!<%H%&%'%$(BIP$B%"%I%l%9(B
/* $B4X?t%W%m%H%?%$%T%s%0(B */
void Delay_ms( unsigned int t);
void Send(unsigned char Data);
void SendStr(unsigned char * str);
void SendCmd(const unsigned char *cmd);
void Process(void);
unsigned int Chunk(unsigned char *buf);
void PlayStop(void);

/*********** $B%a%$%s4X?t(B **************************/
int main(void){
    /* $B%/%m%C%/$N@_Dj!!(B7.37MHz*4=32MHz */
    CLKDIVbits.PLLPRE = 0;                  // 7.37MHz /2=3.685
    PLLFBDbits.PLLDIV = 42;                 // 3.685MHz * 44 = 162
    CLKDIVbits.PLLPOST = 0;                 // 162mHz / 2 = 81MHz -> 40MIPS
    /* I/O$B$N=i4|@_Dj(B */
    AD1PCFGL = 0xFFFF;                      // $B$9$Y$F%G%8%?%k$K%;%C%H(B
    TRISA = 0x001C;                         // RA2,3 input
    TRISB = 0xFCD4;                         // RB2,3,5,8,9 Output
    /* $B%9%$%C%A4XO"@_Dj(B */
    CNPU2bits.CN24PUE = 1;                  // RB6 Pullup
    /* WiFi$B%b%8%e!<%k=i4|2=(B */
    LATBbits.LATB9 = 0;                     // WiFi$B%b%8%e!<%k%j%;%C%H(B
    Delay_ms(100);                          // $B%Q%k%9I}3NJ](B
    LATBbits.LATB9 = 1;                     // $B%j%;%C%H2r=|(B
    Delay_ms(500);                          // $B=i4|2=40N;BT$A(B
    /* UART1$B%T%s3dIU(B */
    RPINR18bits.U1RXR = 7;                  // UART1 RX to RP7
    RPOR4bits.RP8R = 3;                     // UART1 TX to RP8
    /* UART1$B=i4|@_Dj!!(B9.6kbps  */
    U1MODE = 0x8808;                        // UART1$B=i4|@_Dj(B BRGH=1
    U1STA =  0x0400;                        // UART1$B=i4|@_Dj(B
    U1BRG = 1040;                           // 9.6kbps
    IPC2bits.U1RXIP = 4;                    // UART1$B3d$j9~$_%l%Y%k(B
    IEC0bits.U1RXIE = 1;                    // UART1$B<u?.3d$j9~$_5v2D(B
    U1MODEbits.UARTEN = 1;
    /* Wi-Fi$B%b%8%e!<%k$N@_Dj(B */
    if(PORTBbits.RB6 == 0){                 // S1$B$,2!$5$l$F$$$k>l9g(B
        /***************************************************************/
        /* WiFi$B%b%8%e!<%k=i4|2=!!%$%s%U%i%b!<%I(B */
//        Delay_ms(500);                      // $BL5Aw?.;~4V3NJ](B
//        SendCmd(msg1);                      // $$$$B$G%3%^%s%I%b!<%I$X(B
//        SendCmd(msg2);                      // $B9)>l=P2Y;~%j%;%C%H(B
//        SendCmd(msg3);                      // SSID$B%;%C%H(B
//        SendCmd(msg4);                      // PIN$B%3!<%I%;%C%H(B
//        SendCmd(msg41);                     // $BL>>N@_Dj(B
//        SendCmd(msg5);                      // $B%W%m%H%3%k;XDj!J(BTCP+UDP)
//        SendCmd(msg51);                     // $B<+F0@\B3M-8z2=(B
//        SendCmd(msg6);                      // $B%j%b!<%H(BIP$B%"%I%l%9;XDj(B
//        SendCmd(msg7);                      // $B%j%b!<%H%]!<%HHV9f;XDj(B
//        SendCmd(msg8);                      // $B<+J,$N%]!<%HHV9f;XDj(B
//        SendCmd(msg9);                      // $B%V%m!<%I%-%c%9%HDd;_(B
//        SendCmd(msg10);                     // Hello$B%a%C%;!<%86X;_(B
//        SendCmd(msg11);                     // Open$B%a%C%;!<%86X;_(B
//        SendCmd(msg12);                     // save
//        SendCmd(msg13);                     // reboot
//        /** USART $B:F@_Dj(B*/
//        U1MODE = 0x8808;                    // UART1$B=i4|@_Dj(B BRGH=1
//        U1STA =  0x0400;                    // UART1$B=i4|@_Dj(B
        /***************************************************************/
        /* WiFi$B%b%8%e!<%k=i4|2=!!%=%U%H(BAP$B%b!<%IMQ(B */
        Delay_ms(500);                      // $BL5Aw?.;~4V3NJ](B
        SendCmd(msg1);                      // $$$$B$G%3%^%s%I%b!<%I$X(B
        SendCmd(msg2);                      // $B9)>l=P2Y;~%j%;%C%H(B
        SendCmd(msg21);                     // $B%=%U%H(BAP$B%b!<%I;XDj(B
        SendCmd(msg22);                     // SSID$B;XDj(B
        SendCmd(msg23);                     // DHCP$B%5!<%PM-8z2=(B
        SendCmd(msg24);                     // IP$B%"%I%l%9;XDj(B
        SendCmd(msg25);                     // $B%5%V%M%C%H%^%9%/;XDj(B
        SendCmd(msg26);                     // $B%2!<%H%&%'%$(BIP$B%"%I%l%9;XDj(B
        SendCmd(msg12);                     // save
        SendCmd(msg13);                     // reboot
        /** USART $B:F@_Dj(B*/
        U1MODE = 0x8808;                    // UART1$B=i4|@_Dj(B BRGH=1
        U1STA =  0x0400;                    // UART1$B=i4|@_Dj(B
        /****************************************************************/
    }
    /* SPI$B$N%T%s3d$jIU$1(B  */
    RPINR20bits.SDI1R = 3;                  // SDI1$B$r(BRP3$B$K(B
    RPOR0bits.RP0R = 8;                     // SCK1$B$r(BRP0$B$K(B
    RPOR0bits.RP1R = 7;                     // SDO1$B$r(BRP1$B$K(B
    /*  $BJd=u%/%m%C%/=i4|2=(B */
    ACLKCONbits.SELACLK = 1;                // Select SOSC 11MHz
    ACLKCONbits.AOSCMD = 1;                 // HS mode
    ACLKCONbits.APSTSCLR = 7;               // 1/1
    ACLKCONbits.ASRCSEL = 0;                // Select SOSC
    /* $B%*!<%G%#%*(BDAC$B$N=i4|2=(B */
    DAC1CONbits.FORM = 1;                   // signed int
    DAC1CONbits.DACFDIV = 0;                // No divide
    DAC1STATbits.LOEN = 1;                  // Left Out Enable
    DAC1STATbits.LITYPE = 0;                // Interrupt not full
    DAC1STATbits.ROEN = 1;                  // Right Out Enable
    DAC1STATbits.RITYPE = 1;                // Interrupt not full
    DAC1DFLT = 0;                           // default out
    DAC1LDAT = 0;                           // mid out
    DAC1RDAT = 0;                           // mid out
    DAC1CONbits.DACEN = 1;                  // DAC Enable
    IFS4bits.DAC1LIF = 0;                   // Left Flag Clear
    IFS4bits.DAC1RIF = 0;                   // Right Flag Clear
    /* $B%+!<%I$N<BAu3NG'$H%G%#%l%/%H%jFI$_9~$_(B $B!J1J5WBT$A!K(B */
    while(!FSInit());                       // FAT$B$N=i4|2=(B
    /* $BJQ?t$N=i4|2=(B */
    Mode = 1;
    Flag = 0;
    SDFlag = 0;
    EndFlag = 0;

    /*************** $B%a%$%s%k!<%W(B ********************/
    while(1){
        /**** Wi-Fi$B%G!<%?<u?.=hM}$N>l9g(B ****/
        if(RcvFlag){                        // $B<u?.$"$j$N>l9g(B
            RcvFlag = 0;                    // $B<u?.%U%i%0%/%j%"(B
            /* $B<u?.%3%^%s%I=hM}(B */
            if((Buffer[0] == 'S')){         // $B%X%C%@3NG'(B
                SndBuf[0] = 'M';            // $B%X%C%@%;%C%H(B
                SndBuf[1] = Buffer[1];      // $B%X%C%@%;%C%H(B
                Process();                  // $B%3%^%s%I=hM}<B9T(B
                Index = 0;                  // $B%P%C%U%!%]%$%s%?%j%;%C%H(B
             }
        }
        /** $B2;3Z:F@8=hM}$N>l9g%b!<%I$GJ,4t(B ***/
        switch(Mode){
            /******* $B:G=i$N2;3Z%G!<%?$N=PNO$N>l9g(B ************/
            case 1:
                /* $B:G=i$N%U%!%$%k$N%5!<%A!J%k!<%H$@$1$K(BWAV$B%U%!%$%k$,$"$k$3$H$,A0Ds!K(B  */
                result = FindFirst("*.*", ATTR_ARCHIVE, rptr);
                if(result == 0){
                    LATAbits.LATA0 = 0;
                    fptr = FSfopen(Record.filename, FS_READ);           // $B%U%!%$%k$N%*!<%W%s(B
                    if(fptr != 0){                                      // $B@5>o%*!<%W%s$N>l9g(B
                        Flag = 0;                                       // BufferA$B;XDj(B
                        SDFlag = 0;                                     // SD$BFI$_=P$7%U%i%0%/%j%"(B
                        /** $B:G=i$N%G!<%?FI$_=P$7(B ***/
                        count = FSfread(BufferA, 1, 4096, fptr);        // $B:G=i$NFI$_=P$7(B
                        ptrA = Chunk(BufferA);                          // WAV$B%U%!%$%k$N@hF,;XDj(B
                        ptrB = 0;                                       // $B%]%$%s%?%j%;%C%H(B
                        SDFlag = 1;                                     // BufferB$B$X$b2DG=$5$;$k(B
                        Mode = 2;                                       // $B<!$N%b!<%I$X(B
                        IEC4bits.DAC1LIE = 1;                           // Lch$B3d$j9~$_5v2D(B
                    }
                }
                /** $B%U%!%$%k%*!<%W%s$G$-$J$+$C$?>l9g(B  **/
                else{
                    LATAbits.LATA0 = 1;
                }
                break;
            /******** $B%U%!%$%k$N:F@87QB3$N>l9g(B  **************/
            case 2:
                if(SDFlag){                                         // $BFI$_=P$7%U%i%0%*%s$N>l9g(B
                    SDFlag = 0;                                     // $BFI$_=P$7%U%i%0%/%j%"(B
                    if(Flag == 0){                                  // $B%P%C%U%!@Z$jBX$(%U%i%03NG'(B
                        /* 4k$B%P%$%HC10L!!%P%C%U%!(BB$BB&$K3JG<!!(B*/
                        count = FSfread(BufferB, 1, 4096, fptr);    // $B%P%C%U%!(BB$B$KFI$_=P$7(B
                        ptrB = 0;                                   // $B%]%$%s%?(BB$B%j%;%C%H(B
                    }
                    else{                                           // $B%P%C%U%!(BA$BB&$K3JG<$N>l9g(B
                        count = FSfread(BufferA, 1, 4096, fptr);    // $B%P%C%U%!(BA$B$KFI$_=P$9(B
                        ptrA = 0;                                   // $B%]%$%s%?(BA$B%j%;%C%H(B
                    }
                    /******* SW2$B$N%A%'%C%/!!6JAw$j(B *********/
                    if(PORTBbits.RB6 == 0){                         // SW2$B%*%s$N>l9g(B
                        EndFlag = 1;                                // $B=*N;%U%i%0%;%C%H(B
                     }
                    /***** $B6J=*N;$+6JAw$j%9%$%C%A$N=hM}(B **/
                    if((count == 0) || (EndFlag)){                  // $B%U%!%$%k=*N;$+=*N;%U%i%0%*%s$N>l9g(B
                        /***** $B:F@840N;=hM}(B *****/
                        PlayStop();
                        Delay_ms(1000);                                     // $B6J4V$N4V(B
                        /* $BO"B3:F@8$N$?$a<!$N%U%!%$%k%5!<%A(B */
                        result = FindNext(rptr);                            // $B<!$N%U%!%$%k$X(B
                        if((result==0)&&(Record.attributes==ATTR_ARCHIVE)){ // $B%U%!%$%k$,$"$C$?>l9g(B
                            fptr = FSfopen(Record.filename, FS_READ);       // $B%U%!%$%k$r%*!<%W%s(B
                            /** $B:G=i$N%G!<%?FI$_=P$7(B ***/
                            count = FSfread(BufferA, 1, 4096, fptr);        // $B:G=i$NFI$_=P$7(B
                            Flag = 0;
                            ptrA = Chunk(BufferA);                          // WAV$B%U%!%$%k$N@hF,;XDj(B
                            ptrB = 0;                                       // $B%P%C%U%!%]%$%s%?%j%;%C%H(B
                            SDFlag = 1;                                     // BufferB$B$X$b2DG=$5$;$k(B
                            if(EndFlag){                                    // $B%9%$%C%A6JAw$j$N>l9g(B
                                EndFlag = 0;                                // $B=*N;%U%i%0%/%j%"(B
                            }
                            IEC4bits.DAC1LIE = 1;                           // Lch$B3d$j9~$_5v2D(B
                        }
                        else   /* $BA4%U%!%$%k=*N;$J$i:G=i$+$i7+$jJV$7(B  */
                            Mode = 1;                                       // $B%b!<%I(B1$B$KLa$k(B
                    }
                }
                break;
            default :  break;                                               // $B$I$l$G$b$J$$>l9g(B
        }
    }
}
/*********************************
 *  $B%G!<%?%A%c%s%/%5!<%A4X?t(B
 *********************************/
unsigned int Chunk(unsigned char *buf){
    unsigned local;
    local = 36;
    while(!((buf[local]=='d')&&(buf[local+1]=='a')&&(buf[local+2]=='t')&&(buf[local+3]=='a')))
        local++;
    return(local+8);
}
/****************************************
 *$B!!<u?.%G!<%?=hM}4X?t(B
 ****************************************/
void Process(void){
    /* $B%G!<%?=hM}(B  */
    switch(Buffer[1]){                      // $B<u?.%G!<%?$GJ,4t(B
        /* $B%F%9%H$N>l9g(B */
        case 'B':
            SndBuf[2] = '1';
            SndBuf[3] = '2';
            SndBuf[4] = '3';
            SndBuf[5] = '4';
            SndBuf[6] = 'E';                // $B=*N;%^!<%/(B
            SendStr(SndBuf);                // $BAw?.<B9T(B
            break;
        /* $B=PNO@)8f$N>l9g(B */
        case 'C':
            switch(Buffer[2]){              // $B6hJL5-9f$GJ,4t(B
                case '1':                   // $B=PNO#1<B9T(B
                    LATAbits.LATA0 = 1;
                    break;
                case '2':                   // $B=PNO(B2$B<B9T(B
                    LATAbits.LATA0 = 0;
                    break;
                default: break;
            }
            break;
        /* $B%U%!%$%kL>>N0l3gAw?.$N>l9g(B */
        case 'F':
            /***** $B:F@840N;=hM}(B *****/
            PlayStop();
            Delay_ms(100);                                  //
            /**** $B%U%!%$%kL>0l3g<hF@(B ($B:GBg(B100$B8D$^$G!K(B****/
            j = 0;                                          // $B%+%&%s%?%j%;%C%H(B
            result = FindFirst("*.*", ATTR_ARCHIVE, rptr);  // $B:G=i$N%U%!%$%k%5!<%A(B
            while((result == 0) && (j < 1200)){             // 100$B8D0J2<$G8+$D$+$C$?>l9g(B
                DirList[j++] = 'M';
                DirList[j++] = 'F';
                k = 0;
                while(Record.filename[k] != 0){             // $B%U%!%$%kL>%3%T!<(B
                    DirList[j] = Record.filename[k];      // $BAw?.%P%C%U%!$X(B
                    j++;
                    k++;
                }
                result = FindNext(rptr);                    // $B<!$N%U%!%$%k%5!<%A(B
            }
            DirList[j++] = 0;
            /*** $B%U%!%$%kL>%j%9%H0l3gAw?.(B  ****/
            j = 0;
            while(DirList[j] != 0)
                Send(DirList[j++]);                         // $BAw?.<B9T(B
            break;
        case 'G':
            /***** $B:F@840N;=hM}(B *****/
            PlayStop();
            Delay_ms(100);                                  //
            /*** $B<u?.%U%!%$%kL>%3%T!<(B ****/
            for(j=0; j<12; j++){
                Serch[j] = Buffer[j+2];
            }
            result = FindFirst((const char*)Serch, ATTR_ARCHIVE, rptr);
            if(result == 0){
                fptr = FSfopen(Record.filename, FS_READ);   // $B%U%!%$%k$N%*!<%W%s(B
                if(fptr != 0){                              // $B@5>o%*!<%W%s$N>l9g(B
                    Flag = 0;                               // BufferA$B;XDj(B
                    SDFlag = 0;                             // SD$BFI$_=P$7%U%i%0%/%j%"(B
                    /** $B:G=i$N%G!<%?FI$_=P$7(B ***/
                    count = FSfread(BufferA, 1, 4096, fptr);// $B:G=i$NFI$_=P$7(B
                    ptrA = Chunk(BufferA);                  // WAV$B%U%!%$%k$N@hF,;XDj(B
                    ptrB = 0;                               // $B%]%$%s%?%j%;%C%H(B
                    SDFlag = 1;                             // BufferB$B$X$b2DG=$5$;$k(B
                    Mode = 2;                               // $B<!$N%b!<%I$X(B
                    IEC4bits.DAC1LIE = 1;                   // Lch$B3d$j9~$_5v2D(B
                }
            }
            break;
        /* $B=*N;%3%^%s%I$N>l9g(B */
        case 'N':
            /***** $B:F@840N;=hM}(B *****/
            PlayStop();
            Mode = 1;
            Delay_ms(100);                      //
            /***************/
            SendCmd(msg1);                      // $$$$B$G%3%^%s%I%b!<%I$X(B
            SendCmd(msg14);                     // Close$BAw?.(B
            SendCmd(msg13);                     // Reboot$BAw?.(B
            /** USART $B:F@_Dj(B*/
            U1MODE = 0x8808;                    // UART1$B=i4|@_Dj(B BRGH=1
            U1STA =  0x0400;                    // UART1$B=i4|@_Dj(B            
            break;
        default: break;
    }
}
/*****************************************
 * $B:F@840N;=hM}%5%V4X?t(B
 ****************************************/
void PlayStop(void){
    /***** $B:F@840N;=hM}(B *****/
    IEC4bits.DAC1LIE = 0;               // Lch$B3d$j9~$_6X;_(B
    /* $B%P%C%U%!%/%j%"(B */
    for(i=0; i<4096; i++){
        BufferA[i] = 0;
        BufferB[i] = 0;
    }
    FSfclose(fptr);                     // $B%U%!%$%k$N%/%m!<%:(B
}
/******************************************
 *  DACL$B3d$j9~$_=hM}4X?t(B
 *****************************************/
void __attribute__((interrupt, no_auto_psv)) _DAC1LInterrupt(void)
{
    IFS4bits.DAC1LIF = 0;                                       // $B3d$j9~$_%U%i%0%/%j%"(B
    /******** $B%P%C%U%!(BA$B$N>l9g(B **********/
    if(Flag == 0){                                              // $B%P%C%U%!(BA$B$N>l9g(B
        DAC1LDAT = BufferA[ptrA+1] * 256 + BufferA[ptrA];       // $B<!$N(BLch$B%G!<%?=PNO(B
        ptrA += 2;                                              // $B%]%$%s%?(BA$B99?7(B
        while(DAC1STATbits.RFULL);                              // Rch$B6u$-BT$A(B
        DAC1RDAT = BufferA[ptrA+1] * 256 + BufferA[ptrA];       // $B<!$N(BRch$B%G!<%?=PNO(B
        ptrA += 2;                                              // $B%]%$%s%?(BA$B99?7(B
        if(ptrA >= count){                                      // $B%P%C%U%!=*N;$N>l9g(B
            Flag = 1;                                           // $B%P%C%U%!@Z$jBX$((B
            SDFlag = 1;                                         // SD$BFI$_=P$7%U%i%0%;%C%H(B
            ptrA = 0;                                           // $B%]%$%s%?(BA$B%j%;%C%H(B
        }
    }
    /********** $B%P%C%U%!(BB$B$N>l9g(B  ***********/
    else{                                                       // $B%P%C%U%!(BB$B$N>l9g(B
        DAC1LDAT = BufferB[ptrB+1] * 256 + BufferB[ptrB];       // $B<!$N(BLch$B%G!<%?=PNO(B
        ptrB += 2;                                              // $B%]%$%s%?(BB$B99?7(B
        while(DAC1STATbits.RFULL);                              // Rch$B6u$-BT$A(B
        DAC1RDAT = BufferB[ptrB+1] * 256 + BufferB[ptrB];       // $B<!$N(BRch$B%G!<%?=PNO(B
        ptrB += 2;                                              // $B%]%$%s%?(BB$B99?7(B
        if(ptrB >= count){                                      // $B%P%C%U%!=*N;$N>l9g(B
            Flag = 0;                                           // $B%P%C%U%!@Z$jBX$((B
            SDFlag = 1;                                         // SD$BFI$_=P$7%U%i%0%;%C%H(B
            ptrB = 0;                                           // $B%]%$%s%?(BB$B%j%;%C%H(B
        }
    }
}
/***************************************
 *  USART$B<u?.3d$j9~$_=hM}4X?t(B
 *  TCP$B<u?.=hM}!"=[4D%P%C%U%!$K3JG<$9$k(B
****************************************/
void __attribute__((interrupt, no_auto_psv))  _U1RXInterrupt(void)
{
    char  data;
    int j;
    /* $B<u?.%(%i!<%A%'%C%/(B */
    IFS0bits.U1RXIF = 0;                            // $B3d$j9~$_%U%i%0%/%j%"(B
    if(U1STAbits.OERR || U1STAbits.FERR) {          // $B%(%i!<$"$j$N>l9g(B
        data = U1RXREG;                             // $B%G!<%?%@%_!<<h$j=P$7(B
        U1STA &= 0xFFF0;                            // $B%(%i!<%U%i%0%/%j%"(B
        U1MODE = 0;                                 // UART1$BDd;_(B
        U1MODE = 0x8808;                            // UART1$BM-8z2=(B
    }
    else {                                          // $B@5>o<u?.$N>l9g(B
        if(Index<32){                               // $B%P%C%U%!1[$($F$$$J$$>l9g(B
            data = U1RXREG;                         // $B%G!<%?<h$j=P$7J]B8(B
            if(data == 'S')                         // $B3+;O%^!<%/$N>l9g(B
                Index = 0;                          // $B%P%C%U%!%$%s%G%C%/%9%j%;%C%H(B
            RcvBuf[Index] = data;                   // $B%G!<%?3JG<(B
            /* $B=*N;%^!<%/$N=hM}(B */
            if(RcvBuf[Index] == 'E'){               // $B=*N;%^!<%/(BE$B8!=P(B
                j = 0;                              // $B%]%$%s%?%j%;%C%H(B
                while(j <= Index){                  // $B<u?.%P%$%H?t7+$jJV$7(B
                    Buffer[j] = RcvBuf[j];          // $B%3%T!<(B
                    j++;                            // $B%P%C%U%!%]%$%s%?99?7(B
                }
                RcvFlag = 1;                        // $B<u?.40N;%U%i%0%;%C%H(B
            }
            Index++;                                // $B%P%C%U%!%]%$%s%?99?7(B
        }
        else{                                       // $B%3%^%s%I<B9T%b!<%I$G$J$$>l9g(B
            data = U1RXREG;                         // $BFI$_Ht$P$7$FL5;k(B
            Index = 0;
        }
    }
}
 /********************************
 * USART $BAw?.<B9T%5%V4X?t(B
 ********************************/
void Send(unsigned char Data){
    while(!U1STAbits.TRMT);                     // $BAw?.%l%G%#!<BT$A(B
    U1TXREG = Data;                             // $BAw?.<B9T(B
}
/********************************
 * WiFi$BJ8;zNsAw?.4X?t(B
 *******************************/
void SendStr(unsigned char * str)
{
    for(i=0; i<32; i++)                         // 32$B%P%$%H8GDj?tAw?.(B
        Send(*str++);                           // TCP$BAw?.<B9T(B
}
/********************************
 * WiFi$B%3%^%s%IAw?.4X?t(B
 * $BCY1dA^F~8eLa$k(B
 ********************************/
void SendCmd(const unsigned char *cmd)
{
    while(*cmd != 0)                            // $BJ8;zNs=*C<$^$G7+$jJV$7(B
        Send(*cmd++);                           // $BAw?.<B9T(B
    Delay_ms(1000);                             // $BJV?.<u?.%9%-%C%W(B
}
/*********************************************************
* $BCY1d4X?t(B  1msec 1usec @40MMHz
**********************************************************/
void Delay_ms( unsigned int t){
    T2CON = 0x8000;                             // enable tmr2, Tcy, 1:1
    while (t--)    {
        TMR2 = 0;
        while (TMR2<40000);
    }
}

